/*
 * Created on May 10, 2005
 *
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 * 
 */
package com.sunlabs.archsim.gasp;

import com.sunlabs.archsim.base.common.Parameters;
import com.sunlabs.archsim.base.hierarchy.CompositeEntity;

/**
 * @author ib27688
 *
 * A model of a component used in the XML front end.
 * The assumtion is that components interface through terminals that
 * are attached to actions.
 *
 */
public abstract class Component extends CompositeEntity {
	
	public Component(String name, Parameters params) {
		super(name);
	}
	
	public abstract Terminal getTerminal(String name);
	
} // Component
